/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_AGENCIA                                                  */
/* Tabela : AGENCIA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_AGENCIA
BEFORE INSERT OR UPDATE OR DELETE
ON AGENCIA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUAGEN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDAGENCIA,0) <> NVL(:NEW.CDAGENCIA,0)) OR
         (NVL(:OLD.NMAGENCIA,0) <> NVL(:NEW.NMAGENCIA,0)) OR
         (NVL(:OLD.CDBANCO,0)   <> NVL(:NEW.CDBANCO,0)) THEN
         :NEW.DTULTATUAGEN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('AGENCIA', '', 'CDBANCO='||:OLD.CDBANCO||';CDAGENCIA='||:OLD.CDAGENCIA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE AGENCIA MODIFY DTULTATUAGEN DEFAULT SYSDATE
/
