/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EQUIPAPROD                                               */
/* Tabela : EQUIPAPROD                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2006 - Arnaldo Coutinho Brito Jnior                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'DTULTATU_EQUIPAPROD'
              AND TYPE = 'TR'
              AND U.UID = O.UID
              AND U.NAME = USER)

   DROP TRIGGER DTULTATU_EQUIPAPROD
GO
   

CREATE TRIGGER DTULTATU_EQUIPAPROD
ON EQUIPAPROD FOR INSERT, UPDATE, DELETE
AS

BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       (SELECT 'EQUIPAPROD', '', 'CDEQUIPPRO='+CDEQUIPPRO+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EQUIPAPROD
      SET  DTULTATUEPRO = GETDATE()
      FROM INSERTED
      WHERE ISNULL(EQUIPAPROD.CDEQUIPPRO,0) = ISNULL(INSERTED.CDEQUIPPRO,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_EQUIPAPROD','5.05.016';
GO
